import java.util.*;
import java.awt.event.*;
import java.awt.*;

class Modellen extends Observable{
    private String farg;
    public Modellen(){
	farg = "Svart";
    }
    public String geFargen(){ 
	return farg;
    }
    
    public void uppdateraTillstand(){ 
	if(farg.equals("Svart"))
	    farg = "Vit"; 
	else
	    farg = "Svart";
	setChanged();
	notifyObservers();
    } 
}

class Vy extends Frame implements Observer{ 
    private Modellen mod;

    public Vy(Modellen m){
	super("Vyn");
	setSize(200,200);
	mod = m;
	mod.addObserver(this);
	setLayout(new BorderLayout());
	setVisible(true);
    }
    
    public void update(Observable o, Object arg){
	repaint();
    }

    public void updatemin(){ 
	repaint();
    } 
    
    public void paint(Graphics g){
	String f = mod.geFargen();
	g.drawString(f, 50,50);
    }

}


class Kontroll extends Button implements ActionListener{ 
    
    private Modellen mod;

    public Kontroll(Modellen m){
	super("klicka pa mig");
	mod = m;
	addActionListener(this);
    }

    public void actionPerformed(ActionEvent ae){
	uppdatera();
    }
    
    public void uppdatera() { 
	mod.uppdateraTillstand();
	//	vy.updatemin();
    }


}



public class MVC1{
    public static void main(String[] args){ 
	Modellen mod = new Modellen(); 
	Vy vy = new Vy(mod);
	Kontroll kontr = new Kontroll(mod);
	vy.add(kontr,BorderLayout.SOUTH);
	
    } 
}
